#ifndef _COMPAT_H_
#define _COMPAT_H_

typedef long            PARAM;
typedef unsigned int    UINT;
typedef unsigned short  WORD;
typedef unsigned char   UCHAR;
typedef unsigned char   BYTE;
typedef unsigned long   ULONG;
typedef signed   long   LONG;
typedef unsigned long   DWORD;
typedef char far *      LPSTR;
typedef unsigned char * UPSTR;
typedef char *          PSTR;

#ifndef TRUE
#define TRUE            1
#define FALSE           0
#endif

#define LOBYTE(x)           (char) (x & 0xFF)
#define HIBYTE(x)           (char) ((x & 0xFF00) >> 8)
#define LOWORD(l)           ((WORD)(DWORD)(l))
#define HIWORD(l)           ((WORD)((((DWORD)(l)) >> 16) & 0xFFFF))
#define MAKELONG(low, high) ((LONG)(((WORD)(low)) | (((DWORD)((WORD)(high))) << 16)))
#define poke(a,b,c)         (*((int  far*)MK_FP((a),(b))) = (int)(c))
#define pokeb(a,b,c)        (*((char far*)MK_FP((a),(b))) = (char)(c))
#define peek(a,b)           (*((int  far*)MK_FP((a),(b))))
#define peekb(a,b)          (*((char far*)MK_FP((a),(b))))

#ifdef _MSC_VER
/////////////////////////
#undef  MK_FP
#define MK_FP(s,o)      ((void far *) \
                        (((unsigned long) (s) << 16) | (unsigned) (o)))
#define findfirst(p,f,a) _dos_findfirst(p,a,f)
#define findnext(f)      _dos_findnext(f)
#define ffblk            find_t
#define ff_name          name
#define ff_fsize         size
#define ff_attrib        attrib
#define getvect(v)       _dos_getvect(v)
#define setvect(v,f)     _dos_setvect(v,f)
#define fnsplit          _splitpath
#define fnmerge          _makepath
#define getcurdir(n, b)  _getcwd(b, n)
#define EXTENSION           2
#define FILENAME            4
#define DIRECTORY           8
#define DRIVE               16
#define setdisk(d)          _dos_setdrive((d) + 1, NULL)
#define bioskey             _bios_keybrd
#define MAXPATH             80
#define MAXDRIVE            3
#define MAXDIR              66
#define MAXFILE             9
#define MAXEXT              5

#define FA_NORMAL        _A_NORMAL
#define FA_RDONLY        _A_RDONLY
#define FA_HIDDEN        _A_HIDDEN
#define FA_SYSTEM        _A_SYSTEM
#define FA_LABEL         _A_VOLID
#define FA_DIREC         _A_SUBDIR
#define FA_ARCH          _A_ARCH

////////////////////////
#endif

#ifdef __TURBOC__
#define _asm            asm
#define _outp(a,b)      outp(a,b)
#endif

#endif	// _COMPAT_H_
