#include "microlib.h"

/*
    F4FIELD_INFO
        Field Name
        Type
        Width
        Decimals

    T4TAG_INFO
        Tag name
        Key expression
        Filter Expression
        Unique
        Descending

*/

int incrow(void);

F4FIELD_INFO  dbf_institut[] = {
    { "CODE",          'C',        7,          0 },
    { "TITLE1",        'C',       50,          0 },
    { "TITLE2",        'C',       50,          0 },
    { "TITLE3",        'C',       50,          0 },
    { "ADDRESS1",      'C',       50,          0 },
    { "ADDRESS2",      'C',       50,          0 },
    { "ZIP",           'C',       15,          0 },
    { "CITY",          'C',       20,          0 },
    { "COUNTRY",       'C',       20,          0 },
    { "TOPIC",         'C',        7,          0 },
    { "SUPERVISOR",    'C',        7,          0 },
    { "PHONE1",        'C',       20,          0 },
    { "PHONE2",        'C',       20,          0 },
    { "FAX",           'C',       15,          0 },
    { "TELEX",         'C',       15,          0 },
    { 0, 0, 0, 0 },
};

T4TAG_INFO  tag_institut[] = {
    { "CODE_T",     "CODE",           ".NOT. DELETED()",  0,     0 },
    { "NAME",       "TITLE1",         ".NOT. DELETED()",  0,     0 },
    { 0, 0, 0, 0, 0 },
};

F4FIELD_INFO  dbf_topics[] = {
    { "CODE",          'C',        7,          0 },
    { "ABBREV",        'C',       20,          0 },
    { "DESCR",         'C',       40,          0 },
    { 0, 0, 0, 0 },
};

T4TAG_INFO  tag_topics[] = {
    { "CODE_T",     "CODE",           ".NOT. DELETED()",  0,     0 },
    { "NAME",       "ABBREV",         ".NOT. DELETED()",  0,     0 },
    { 0, 0, 0, 0, 0 },
};

F4FIELD_INFO  dbf_professions[] = {
    { "CODE",          'C',        7,          0 },
    { "DESCR",         'C',       40,          0 },
    { 0, 0, 0, 0 },
};

T4TAG_INFO  tag_professions[] = {
    { "CODE_T",     "CODE",           ".NOT. DELETED()",  0,     0 },
    { 0, 0, 0, 0, 0 },
};

F4FIELD_INFO  dbf_persons[] = {
    { "CODE",          'C',        7,          0 },
    { "SURNAME",       'C',       50,          0 },
    { "NAME",          'C',       50,          0 },
    { "PROFESSION",    'C',       20,          0 },
    { "HADDRESS",      'C',       50,          0 },
    { "HCITY",         'C',       20,          0 },
    { "HZIP",          'C',       10,          0 },
    { "HCOUNTRY",      'C',       20,          0 },
    { "HPHONE1",       'C',       20,          0 },
    { "HPHONE2",       'C',       20,          0 },
    { "HFAX",          'C',       15,          0 },
    { "HTELEX",        'C',       15,          0 },
    { "HENV_TITLE",    'C',       20,          0 },
    { "HLET_TITLE",    'C',       20,          0 },
    { "WADDRESS",      'C',       50,          0 },
    { "WCITY",         'C',       20,          0 },
    { "WZIP",          'C',       10,          0 },
    { "WCOUNTRY",      'C',       20,          0 },
    { "WPHONE1",       'C',       20,          0 },
    { "WEXT1",         'C',        5,          0 },
    { "WPHONE2",       'C',       20,          0 },
    { "WEXT2",         'C',        5,          0 },
    { "WFAX",          'C',       15,          0 },
    { "WTELEX",        'C',       15,          0 },
    { "WENV_TITLE",    'C',       20,          0 },
    { "WLET_TITLE",    'C',       20,          0 },
    { 0, 0, 0, 0 },
};

T4TAG_INFO  tag_persons[] = {
    { "CODE_T",     "CODE",           ".NOT. DELETED()",  0,     0 },
    { "SURNAME",    "SURNAME",        ".NOT. DELETED()",  0,     0 },
    { 0, 0, 0, 0, 0 },
};

C4CODE set;

void main(void)
{
    int w_ref;

    d4init(&set);

    set.auto_open = 1;
    set.safety    = 0;
 
    d4close(d4create(&set, "INSTITUT.DBF", dbf_institut,   tag_institut));
    d4close(d4create(&set, "TOPICS.DBF",   dbf_topics,     tag_topics));
    d4close(d4create(&set, "PROFESS.DBF",  dbf_professions,tag_professions));
    d4close(d4create(&set, "PERSONS.DBF",  dbf_persons,    tag_persons));
}
