#include "microlib.h"

#include "convert.h"
#include "dbfiles.h"

#define IDDFILE(idd)    IDDFILE idd = {
#define NAME(n)         #n,
#define PATH(p)         #p,
#define DESCR(d)        #d,
#define FILENUM(n)      n,
#define FLAGS(f)        f,
#define NUMFLDS(n)      n,
#define FIELDS          {
#define FIELD(a, b, c, d, e, f, g, h) { a, b, c, d, e, f, g, h },
#define ENDFIELDS       { NULL, NULL, 0, 0, 0, 0, 0, 0 } }
#define ENDFILE         };

IDDFILE(iddInstitutes)
    NAME(INSTITUT.DBF)
    PATH(FILES)
    DESCR()
    FILENUM(0)
    FLAGS(0x0L)
    NUMFLDS(16)
    FIELDS
        FIELD("",           "",          0x00000000, FLD_CHAR,   1, FLD_CHAR,     1, TF_ASIS)
        FIELD("CODE",       "",   0x00000000, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
        FIELD("TITLE1",     "П",    0x00000000, FLD_ASCII, 80, FLD_CSTRING, 40, TF_ASIS)
        FIELD("TITLE2",     "П",    0x00000000, FLD_ASCII,100, FLD_CSTRING, 40, TF_ASIS)
        FIELD("TITLE3",     "П",    0x00000000, FLD_ASCII,100, FLD_CSTRING, 40, TF_ASIS)
        FIELD("ADDRESS1",   "ޣ", 0x00000000, FLD_ASCII, 80, FLD_CSTRING, 40, TF_ASIS)
        FIELD("ADDRESS2",   "ޣ", 0x00000000, FLD_ASCII, 80, FLD_CSTRING, 40, TF_ASIS)
        FIELD("ZIP",        "е",        0x00000000, FLD_ASCII, 14, FLD_CSTRING, 14, TF_ASIS)
        FIELD("CITY",       "Ƣ",      0x00000000, FLD_ASCII, 35, FLD_CSTRING, 20, TF_ASIS)
        FIELD("STATE",      "ޟ",  0x00000000, FLD_ASCII, 20, FLD_CSTRING, 20, TF_ASIS)
        FIELD("COUNTRY",    "",      0x00050201, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
        FIELD("TOPIC",      "",      0x00010201, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
        FIELD("SUPERVISOR", "ޣ", 0x00020201, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
        FIELD("PHONE1",     ".1",     0x00000000, FLD_ASCII, 20, FLD_CSTRING, 20, TF_ASIS)
        FIELD("PHONE2",     ".2",     0x00000000, FLD_ASCII, 20, FLD_CSTRING, 20, TF_ASIS)
        FIELD("FAX",        "FAX",       0x00000000, FLD_ASCII, 15, FLD_CSTRING, 15, TF_ASIS)
        FIELD("TELEX",      "TELEX",     0x00000000, FLD_ASCII, 15, FLD_CSTRING, 15, TF_ASIS)
    ENDFIELDS
ENDFILE

IDDFILE(iddTopics)
    NAME(TOPICS.DBF)
    PATH(FILES)
    DESCR()
    FILENUM(1)
    FLAGS(0x0L)
    NUMFLDS(3)
    FIELDS
        FIELD("",           "",              0x00000000, FLD_CHAR,   1, FLD_CHAR,     1, TF_ASIS)
        FIELD("CODE",       "",       0x00000000, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
        FIELD("ABBREV",     "", 0x00000000, FLD_ASCII, 50, FLD_CSTRING, 20, TF_ASIS)
        FIELD("DESCR",      "",     0x00000000, FLD_ASCII, 50, FLD_CSTRING, 40, TF_ASIS)
    ENDFIELDS
ENDFILE

IDDFILE(iddPersons)
    NAME(PERSONS.DBF)
    PATH(FILES)
    DESCR()
    FILENUM(2)
    FLAGS(0x0L)
    NUMFLDS(26)
    FIELDS
        FIELD("",           "",            0x00000000, FLD_CHAR,   1, FLD_CHAR,     1, TF_ASIS)
        FIELD("CODE",       "",     0x00000000, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
        FIELD("SURNAME",    "",     0x00000000, FLD_ASCII, 70, FLD_CSTRING, 40, TF_ASIS)
        FIELD("NAME",       "",       0x00000000, FLD_ASCII, 50, FLD_CSTRING, 40, TF_ASIS)
        FIELD("PROFESSION", "",   0x00000000, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
        FIELD("H_ADDRESS1", "ޣ 1", 0x00000000, FLD_ASCII,100, FLD_CSTRING, 40, TF_ASIS)
        FIELD("H_ADDRESS2", "ޣ 2", 0x00000000, FLD_ASCII,100, FLD_CSTRING, 40, TF_ASIS)
        FIELD("H_ZIP",      "е",          0x00000000, FLD_ASCII, 20, FLD_CSTRING, 20, TF_ASIS)
        FIELD("H_CITY",     "Ƣ",        0x00000000, FLD_ASCII, 35, FLD_CSTRING, 20, TF_ASIS)
        FIELD("H_STATE",    "ޟ",    0x00000000, FLD_ASCII, 20, FLD_CSTRING, 20, TF_ASIS)
        FIELD("H_COUNTRY",  "",        0x00000000, FLD_ASCII, 20, FLD_CSTRING, 20, TF_ASIS)
        FIELD("H_PHONE1",   ".1",       0x00000000, FLD_ASCII, 20, FLD_CSTRING, 20, TF_ASIS)
        FIELD("H_PHONE2",   ".2",       0x00000000, FLD_ASCII, 20, FLD_CSTRING, 20, TF_ASIS)
        FIELD("H_FAX",      "FAX",         0x00000000, FLD_ASCII, 15, FLD_CSTRING, 15, TF_ASIS)
        FIELD("H_TELEX",    "TELEX",       0x00000000, FLD_ASCII, 15, FLD_CSTRING, 15, TF_ASIS)
        FIELD("H_ENVELOPE", "?????????",   0x00000000, FLD_ASCII, 30, FLD_CSTRING, 20, TF_ASIS)
        FIELD("H_LETTER",   "?????????",   0x00000000, FLD_ASCII, 30, FLD_CSTRING, 20, TF_ASIS)
        FIELD("INSTITUTE",  "",      0x00000000, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
        FIELD("POSITION",   "",        0x00000000, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
        FIELD("W_PHONE1",   ".1",       0x00000000, FLD_ASCII, 20, FLD_CSTRING, 20, TF_ASIS)
        FIELD("W_EXT1",     "Ext.1",       0x00000000, FLD_ASCII,  5, FLD_CSTRING,  5, TF_ASIS)
        FIELD("W_PHONE2",   ".2",       0x00000000, FLD_ASCII, 20, FLD_CSTRING, 20, TF_ASIS)
        FIELD("W_EXT2",     "Ext.2",       0x00000000, FLD_ASCII,  5, FLD_CSTRING,  5, TF_ASIS)
        FIELD("W_FAX",      "FAX",         0x00000000, FLD_ASCII, 15, FLD_CSTRING, 15, TF_ASIS)
        FIELD("W_TELEX",    "TELEX",       0x00000000, FLD_ASCII, 15, FLD_CSTRING, 15, TF_ASIS)
        FIELD("W_ENVELOPE", "?????????",   0x00000000, FLD_ASCII, 30, FLD_CSTRING, 20, TF_ASIS)
        FIELD("W_LETTER",   "?????????",   0x00000000, FLD_ASCII, 30, FLD_CSTRING, 20, TF_ASIS)
    ENDFIELDS
ENDFILE

IDDFILE(iddStates)
    NAME(STATES.DBF)
    PATH(FILES)
    DESCR(ޟ)
    FILENUM(4)
    FLAGS(0x0L)
    NUMFLDS(2)
    FIELDS
        FIELD("",           "",              0x00000000, FLD_CHAR,   1, FLD_CHAR,     1, TF_ASIS)
        FIELD("CODE",       "",       0x00000000, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
        FIELD("NAME",       "ޟ",      0x00000000, FLD_ASCII, 20, FLD_CSTRING, 20, TF_ASIS)
    ENDFIELDS
ENDFILE

IDDFILE(iddCountries)
    NAME(COUNTRY.DBF)
    PATH(FILES)
    DESCR()
    FILENUM(5)
    FLAGS(0x0L)
    NUMFLDS(3)
    FIELDS
        FIELD("",           "",              0x00000000, FLD_CHAR,   1, FLD_CHAR,     1, TF_ASIS)
        FIELD("CODE",       "",       0x00000000, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
        FIELD("COUNTRY",    "",          0x00000000, FLD_ASCII, 20, FLD_CSTRING, 20, TF_ASIS)
        FIELD("PREFIX",     "",       0x00000000, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
    ENDFIELDS
ENDFILE

IDDFILE(iddForms)
    NAME(FORMS.DBF)
    PATH(FILES)
    DESCR(Ң)
    FILENUM(6)
    FLAGS(0x0L)
    NUMFLDS(6)
    FIELDS
        FIELD("",           "",              0x00000000, FLD_CHAR,   1, FLD_CHAR,     1, TF_ASIS)
        FIELD("CODE",       "",       0x00000000, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
        FIELD("NAME",       "",     0x00000000, FLD_ASCII, 80, FLD_CSTRING, 40, TF_ASIS)
        FIELD("PAGE",       ".",   0x00000000, FLD_ASCII,  2, FLD_CSTRING,  2, TF_ASIS)
        FIELD("ORIENT",     "/",   0x00000000, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
        FIELD("HEADER",     "",   0x00000000, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
        FIELD("FILE",       "ޟ",        0x00000000, FLD_ASCII,  7, FLD_CSTRING,  7, TF_ASIS)
    ENDFIELDS
ENDFILE

char _far *IDD[] = {
    (char _far *)&iddInstitutes,
    (char _far *)&iddTopics,
    (char _far *)&iddPersons,
    NULL,
    (char _far *)&iddStates,
    (char _far *)&iddCountries,
    (char _far *)&iddForms,
    NULL
};
