#ifndef _DBFILES_H_
#define _DBFILES_H_

#define _MAX_IDD_FIELDS         35
#define _MAX_IDD_FIELDNAME      15
#define _MAX_IDD_FIELDDESCR     35
#define _MAX_IDD_KEYS           35
#define _MAX_IDD_KEYNAME        15
#define _MAX_IDD_KEYDESCR       35
#define _MAX_IDD_FILENAME       13
#define _MAX_IDD_FILEPATH       64
#define _MAX_IDD_FILEDESCR      50

typedef struct __IDD_HEADER__ {
    unsigned char szID[8];              // ID
    unsigned char szDBMSEngine[20];     // Engine that created file
    unsigned char szDescr[30];          // Description
    unsigned int  wFileCount;           // Count of files
} IDDHEADER;


typedef struct __IDD_KEY__ {
    unsigned char szName[_MAX_IDD_KEYNAME];   // 15
    unsigned char szDescr[_MAX_IDD_KEYDESCR]; // 35
    unsigned int  nPos;                       // file position
    unsigned int  nLength;                    // key length
    unsigned long dwFlag;                     // key flags
    unsigned long dwType;                     // key type
} IDDKEY;

typedef struct __IDD_FIELD__ {
    unsigned char szFldName[_MAX_IDD_FIELDNAME];   // 15
    unsigned char szFldDescr[_MAX_IDD_FIELDDESCR]; // 35
    unsigned long dwFlag;
    //
    // HIWORD(dwFlag)           : the file related to
    // LOBYTE(LOWORD(dwFlag))   : the field related to
    // HIBYTE(LOWORD(dwFlag))   : the field to be printed
    //
    unsigned int  nFileType;                      // file type
    unsigned int  nFileSize;                      // file size
    unsigned int  nCrtType;                       // convertion type
    unsigned int  nCrtSize;                       // display size
    unsigned int  nCrtFormat;                     // display format
} IDDFIELD;

typedef struct __IDDFILE__ {
    unsigned char szName[_MAX_IDD_FILENAME];        // 13
    unsigned char szPath[_MAX_IDD_FILEPATH];        // 64
    unsigned char szDescr[_MAX_IDD_FILEDESCR];      // 50
    unsigned int  wNumber;
    unsigned int  wFlag;
    unsigned int  wNumFlds;
    IDDFIELD Field [_MAX_IDD_FIELDS];           // 35 fields
    //IDDKEY   Key  [_MAX_IDD_KEYS];             // 35 keys
} IDDFILE;

#endif
