#include "microlib.h"
#include <malloc.h>

#include "fxaddons.h"

/************************************************************************/
/* Edit a record                                                        */
/************************************************************************/
int EditRecord(D4DATA *dbfile, IDDFILE *idd, UPSTR cr)
{
    char *rec;
    int  nCurrKey;

    nCurrKey = EditFields(idd, (char *)cr);

    if (nCurrKey == VK_F10) {
        if (warning(mes[MH+7])) {
            rec = d4record(dbfile);
            d4blank(dbfile); // Set "record changed" flag to true.
            memcpy(rec, cr, d4record_width(dbfile));
            d4flush_all(dbfile);
            d4unlock_all_data(dbfile);
            d4unlock_index(dbfile);
        }
    }

    helpline(mes[MH+33]);
    statline(mes[MS+8]);

    return (nCurrKey);
}

/************************************************************************/
/* Display Fields                                                       */
/************************************************************************/
void DisplayFields(IDDFILE *idd, UPSTR cr)
{
    UCHAR   szBuff[256] = {'\0'};
    UPSTR   p = cr;
    int     nCurrFld,
            nMaxFlds = idd->wNumFlds;

    p++; //  skip deleted flag

    for (nCurrFld = 1; nCurrFld <= nMaxFlds; nCurrFld++) {
        if (srow[nCurrFld] == 0) {
            p += idd->Field[nCurrFld].nFileSize;
            continue;
        }
        _db2C(szBuff, FLD_CSTRING, p, idd->Field[nCurrFld].nCrtSize);
        at_say(scol[nCurrFld]+1,
               srow[nCurrFld]+2,
               szBuff,
               '');
        p += idd->Field[nCurrFld].nFileSize;
    }
}

/************************************************************************/
/* Edit Fields                                                          */
/************************************************************************/
int  EditFields(IDDFILE *idd, UPSTR cr)
{
    UCHAR   szBuff[256] = {'\0'};
    UPSTR   p = cr;
    BOOL    bDone = FALSE;
    int     nCurrKey,
            nCurrFld,
            nMaxFlds = idd->wNumFlds;

    p++;    //  skip deleted flag

    //w4attribute(custom[MAIN_I]);
    //w4num(srow[1], scol[1], cr->code, sizeof(cr->code));
    //w4attribute(custom[MAIN_N]);

    helpline(mes[MH+4]);
    statline(mes[MS+4]);

    for (nCurrFld = 1; nCurrFld <= nMaxFlds; nCurrFld++) {
        if (srow[nCurrFld] == 0)
            continue;
        at_say(scol[nCurrFld], srow[nCurrFld]+2, "[", '');
        if (idd->Field[nCurrFld].nFileSize != idd->Field[nCurrFld].nCrtSize)
            at_say(scol[nCurrFld] + idd->Field[nCurrFld].nCrtSize + 1, srow[nCurrFld]+2 , "", '');
        else
            at_say(scol[nCurrFld] + idd->Field[nCurrFld].nCrtSize + 1, srow[nCurrFld]+2 , "]", '');
        if (idd->Field[nCurrFld].dwFlag != 0x00L) {
            long flag = idd->Field[nCurrFld].dwFlag;
            D4DATA *_dbf;
            F4FIELD *_fld;
            IDDFILE *_idd;
            char szFileName[64];
            int  nSeek;

            _idd = (IDDFILE *)IDD[HIWORD(flag)];
            // construct the filename
            strcpy((char *)&szFileName, _idd->szPath);
            strcat((char *)&szFileName, "\\");
            strcat((char *)&szFileName, _idd->szName);

            // open the file, set current position
            _dbf = d4open(&set, (char *)&szFileName);
            d4top(_dbf);
            _db2C(szBuff, FLD_CSTRING, p, idd->Field[nCurrFld].nFileSize);
            nSeek = d4seek(_dbf, szBuff);
            if (nSeek == r4success && szBuff[0] != '\0') {
                _fld = d4field_j(_dbf, HIBYTE(LOWORD(flag)));
                // this is known :
                // if field length exceeds line size, it wraps around
                memcpy((char *)&szBuff, f4str(_fld), _idd->Field[HIBYTE(LOWORD(flag))].nCrtSize);
                at_say(scol[nCurrFld] + idd->Field[nCurrFld].nCrtSize + 3,
                    srow[nCurrFld]+2 ,
                    szBuff,
                    '');
            }
            d4close(_dbf);
        }
        p += idd->Field[nCurrFld].nFileSize;
    }

    nCurrFld = 1;
    p = cr + 1;
    while (!bDone) {
        // not a stable one this one !
        if (srow[nCurrFld] == 0 && nCurrFld != 1) {
            if (nCurrKey == VK_UP) {
                nCurrFld--;
                p -= idd->Field[nCurrFld].nFileSize;
            }
            else {
                p += idd->Field[nCurrFld].nFileSize;
                nCurrFld++;
            }
            continue; // the next one might be out too
        }
        _db2C(szBuff, FLD_CSTRING, p, idd->Field[nCurrFld].nFileSize);
        nCurrKey = GetInput(scol[nCurrFld]+2, srow[nCurrFld]+3, 'G', '', szBuff, "s",
                        idd->Field[nCurrFld].nCrtSize,
                        idd->Field[nCurrFld].nFileSize,
                        ALPHASET);
        _db2C(p, FLD_ASCII, szBuff, idd->Field[nCurrFld].nFileSize);

        switch (nCurrKey) {

            case VK_F10 :
            case VK_ESCAPE :
                bDone = TRUE;
                break;

            case VK_F3 : {
                long flag = idd->Field[nCurrFld].dwFlag;
                int  wide = idd->Field[nCurrFld].nFileSize;
                int  test;
                long retc;
                D4DATA *_dbf;
                F4FIELD *_fld;
                IDDFILE *_idd;
                char *_rec;
                char szFileName[64];
                RECT rc = { 1,
                            0,
                            30,
                            10,
                            color(BLUE,  WHITE, NOBLINK),
                            color(BLUE,  WHITE, NOBLINK),
                            color(BLUE,  WHITE, NOBLINK),
                            color(WHITE, RED,   NOBLINK)
                        };

                if (flag == 0x00L) {
                    putchar(0x07);
                    break;
                }
                _rec = alloca(wide);

                _idd = (IDDFILE *)IDD[HIWORD(flag)];
                // construct the filename
                strcpy((char *)&szFileName, _idd->szPath);
                strcat((char *)&szFileName, "\\");
                strcat((char *)&szFileName, _idd->szName);

                // open the file, set current position
                _dbf = d4open(&set, (char *)&szFileName);
                d4top(_dbf);

                test = LOWORD(flag);
                test = HIBYTE(test);
                rc.right = 2 + _idd->Field[HIBYTE(LOWORD(flag))].nCrtSize;
                retc = ListBox(&rc, HIWORD(flag), LOBYTE(LOWORD(flag)), _dbf);
                if (HIWORD(retc) == (WORD)-1) { // exited with VK_ESCAPE
                    d4close(_dbf);
                    break;
                }
                d4go(_dbf, (long) HIWORD(retc));
                _rec = (char *) d4record(_dbf);
                _rec++;
                memcpy(p, _rec, idd->Field[nCurrFld].nFileSize);
                _fld = d4field_j(_dbf, HIBYTE(LOWORD(flag)));
                // this is known :
                // if field length exceeds line size, it wraps around
                //_db2C(szBuff, FLD_CSTRING, f4str(_fld), idd->Field[nCurrFld].nCrtSize);
                memcpy((char *)&szBuff, f4str(_fld), idd->Field[HIBYTE(LOWORD(flag))].nCrtSize);
                at_say(scol[nCurrFld] + idd->Field[nCurrFld].nCrtSize + 3,
                        srow[nCurrFld]+2 ,
                        szBuff, //m4str(_fld),
                       '');
                d4close(_dbf);
                break;
            }

            case VK_ENTER : {
                long flag = idd->Field[nCurrFld].dwFlag;
                IDDFILE *_idd;
                D4DATA  *_dbf;
                F4FIELD *_fld;
                char *_rec;
                char szFileName[64];

                if (flag == 0x00L) {
                    break;
                }
                _idd = (IDDFILE *)IDD[HIWORD(flag)];
                // construct the filename
                strcpy((char *)&szFileName, _idd->szPath);
                strcat((char *)&szFileName, "\\");
                strcat((char *)&szFileName, _idd->szName);

                // open the file, set current position
                _dbf = d4open(&set, (char *)&szFileName);
                d4seek(_dbf, (char *)&szBuff);
                _rec = (char *) d4record(_dbf);
                _rec++;
                memcpy(p, _rec, idd->Field[nCurrFld].nFileSize);
                _fld = d4field_j(_dbf, HIBYTE(LOWORD(flag)));
                // this is known :
                // if field length exceeds line size,
                // it wraps around
                memcpy((char *)&szBuff, f4str(_fld), idd->Field[HIBYTE(LOWORD(flag))].nCrtSize);
                at_say(scol[nCurrFld] + idd->Field[nCurrFld].nCrtSize + 3,
                        srow[nCurrFld]+2 ,
                        szBuff,
                       '');
                d4close(_dbf);
                }
                break;

            case VK_DOWN :
                p += idd->Field[nCurrFld].nFileSize;
                nCurrFld += 1;
                if (nCurrFld > nMaxFlds) {
                    nCurrFld = 1;
                    p = cr;
                    p++;
                }
                break;

            case VK_UP :
                nCurrFld -= 1;
                if (nCurrFld == 0) {
                    p = cr;
                    p++;
                    for (nCurrFld = 1; nCurrFld < nMaxFlds; nCurrFld++)
                        p += idd->Field[nCurrFld].nFileSize;
                }
                else
                    p -= idd->Field[nCurrFld].nFileSize;
                break;

        }
    }
    return (nCurrKey);
}
