#ifdef  __TURBOC__
#define _asm        asm
#endif

#define NOBLINK       0
#define BLINK       128
#define BG(color)               (char) ((color & 0xf0) >> 4)
#define FG(color)               (char) (color & 0x0f)
#define color(fore, back, blink) (fore | (back << 4) | blink)

#ifndef BLACK
//
#define BLACK                0
#define BLUE                 1
#define GREEN                2
#define CYAN                 3
#define RED                  4
#define MAGENTA              5
#define BROWN                6
#define WHITE                7
#define GRAY                 8
#define LIGHTBLUE            9
#define LIGHTGREEN          10
#define LIGHTCYAN           11
#define LIGHTRED            12
#define LIGHTMAGENTA        13
#define YELLOW              14
#define LIGHTWHITE          15
#define VGA_BROWN           0x14
#define VGA_DARKGRAY        0x38
#define VGA_LIGHTBLUE       0x39
#define VGA_LIGHTGREEN      0x3a
#define VGA_LIGHTCYAN       0x3b
#define VGA_LIGHTRED        0x3c
#define VGA_LIGHTMAGENTA    0x3d
#define VGA_YELLOW          0x3e
#define VGA_BRIGHTWHITE     0X3f
#endif

typedef unsigned int    UINT;
typedef unsigned short  WORD;
typedef unsigned short  BOOL;
typedef unsigned char   UCHAR;
typedef unsigned char   BYTE;
typedef unsigned long   ULONG;
typedef signed   long   LONG;
typedef unsigned long   DWORD;
typedef char far *      LPSTR;
typedef char *          PSTR;
typedef unsigned char * UPSTR;

typedef struct _videostatus_ {
    unsigned int crtmode;                       // support for VESA modes
    unsigned int lastmode;                      // support for VESA modes
    unsigned int screenwide;
    unsigned int screendeep;
    unsigned int txtcols;
    unsigned int txtrows;
    unsigned int numpages;
    unsigned int crtpage;                       // current page
    unsigned int adapter;
    unsigned int monitor;
    unsigned int memory;                        // video memory installed
    char far     *segment;                      // video memory segment
} VIDEOSTATUS;

typedef struct rect {
    int  left;
    int  top;
    int  right;
    int  bottom;
    unsigned char border;
    unsigned char title;
    unsigned char normal;
    unsigned char active;
} RECT;

int  _kbdhit(void);
void _movmem(PSTR, PSTR, int);
void at_say(int, int, UPSTR string, UCHAR attr);
PSTR LJ(PSTR LStr, PSTR Buffer, int);
PSTR RJ(PSTR RStr, PSTR Buffer, int);
PSTR Replace(PSTR Src, PSTR Target, int);
void vioInit(void);                             /* function 0x00 */
void vioSetCurType(int, int, int);              /* function 0x01 */
void vioSetCurPos(int, int);                    /* function 0x02 */
void vioGetCurPos(int *, int *);                /* function 0x03 */
void vioGetCurType(int *, int *);               /* function 0x03 */
void vioSetPage(int);                           /* function 0x05 */
void vioScroll(int, int, int, int, int, int, int); /* function 0x06, 0x07*/
int  vioGetPage(void);                          /* function 0x0F */
int  vioGetCols(void);                          /* function 0x0F */
int  vioGetMode(void);                          /* function 0x0F */
void vioSetBlinkBit(char);                      /* function 0x1003 */

enum VideoModes {
    VMODE_0,
    VMODE_1,
    VMODE_2,
    VMODE_3,
    VMODE_4,
    VMODE_5,
    VMODE_6,
    VMODE_7,
    VMODE_8,
    VMODE_9,
    VMODE_10,
    VMODE_13 = 13,
    VMODE_14,
    VMODE_15,
    VMODE_16,
    VMODE_17,
    VMODE_18,
    VMODE_19
};
