/****************************************************************************\
|*               Include some standard headers in every c file.             *|
\****************************************************************************/
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/*****************************************************************************\
|*               Include Code Base's header files.                           *|
\*****************************************************************************/
#include <d4all.h>
#include <w4.h>
#include <g4char.h>
/*****************************************************************************\
|*                 Enumerations                                              *|
\*****************************************************************************/
enum dbfFiles {
    DBF_DONTCARE1,
    DBF_CLIENT,
    DBF_CL_GROUP,
    DBF_OCCUP,
    DBF_EDUC,
    DBF_CODES,
    DBF_ACTIVITY,
    DBF_CO_TYPE,
    DBF_OPPONENT,
    DBF_OP_GROUP,
    DBF_JUDGE,
    DBF_J_GROUP,
    DBF_COURT,
    DBF_RANK,
    DBF_O_LAWYER,
    DBF_L_GROUP,
    DBF_SPECIAL,
    DBF_LICENSE,
    DBF_EMPLOYEE,
    DBF_CASE,
    DBF_CASGROUP,
    DBF_CASSTAT,
    DBF_CASCATEG,
    DBF_DOCUMENT,
    DBF_PROCED,
    DBF_KWCASDOC,
    DBF_KEYWORDS,
    DBF_CHISTORY,
    DBF_ACTION,
    DBF_DEBIT,
    DBF_CREDIT,
    DBF_REMAIN,
    DBF_DONTCARE2,
    DBF_FIELDS,
    DBF_DONTCARE3,
    DBF_DONTCARE4,
    DBF_PRINTDEF,
    DBF_PRINTANA,
    DBF_INSTITUTES,
    DBF_TOPICS,
    DBF_PROFESSIONS,
    DBF_PERSONS,
    DBF_FORMS
};

enum Screens {
    SCR_DONTCARE1,                              /*  0 */
    SCR_PCLIENT1,                               /*  1 */
    SCR_PCLIENT2,                               /*  2 */
    SCR_CCLIENT,                                /*  3 */
    SCR_POPPONENT,                              /*  4 */
    SCR_COPPONENT,                              /*  5 */
    SCR_JUDGE,                                  /*  6 */
    SCR_O_LAWYER,                               /*  7 */
    SCR_MICROLAND,                              /*  8 */
    SCR_EMPLOYEE,                               /*  9 */
    SCR_ADD_USER,                               /* 10 */
    SCR_LOGIN,                                  /* 11 */
    SCR_SOLICITOR,                              /* 12 */
    SCR_CASE,                                   /* 13 */
    SCR_DOCUMENT,                               /* 14 */
    SCR_KWCASE,                                 /* 15 */
    SCR_KWDOC,                                  /* 16 */
    SCR_FILTCASE,                               /* 17 */
    SCR_ACTION,                                 /* 18 */
    SCR_ACT_TO,                                 /* 19 */
    SCR_ACT_DONE,                               /* 20 */
    SCR_FILTDOC,                                /* 21 */
    SCR_CASEECO,                                /* 22 */
    SCR_CR_EDIT,                                /* 23 */
    SCR_CL_ECO,                                 /* 24 */
    SCR_EMP_ACT,                                /* 25 */
    SCR_FILTCL,                                 /* 26 */
    SCR_PRINTDEF,                               /* 27 */
    SCR_FILTOPPO,                               /* 28 */
    SCR_FILTJUDGE,                              /* 29 */
    SCR_FILTOL,                                 /* 30 */
    SCR_FILT_KW,                                /* 31 */
    SCR_PFILTCAS,                               /* 32 */
    SCR_EMP_ACTA,                               /* 33 */
    SCR_BACKUP,                                 /* 34 */
    SCR_RESTORE,                                /* 35 */
    SCR_NEWCODE,                                /* 36 */
    SCR_INSTITUTES,                             /* 37 */
    SCR_TOPICS,                                 /* 38 */
    SCR_PROFESSIONS,                            /* 39 */
    SCR_PERSONS,                                /* 40 */
    SCR_NEWFORM                                 /* 41 */
};
/*****************************************************************************\
|*                 Definitions.                                              *|
\*****************************************************************************/
#define TRUE        1
#define FALSE       0

#define CSET437

#ifdef _MSC_VER
#define c4ltoa(a, b, c)     c4ltoa45(a, b, c)
#define c4dtoa(a, b, c)     c4ldoa45(a, b, c)
#endif

#define CUT_KEY '*'

#define MT          0
#define ME          MT+50
#define MS          ME+60
#define MH          MS+40

enum MessageTitles {
    MT0,
    MT1,
    MT2,
    MT3,
    MT4,
    MT5,
    MT_PERSONS,
    MT_PROFESSIONS,
    MT_TOPICS,
    MT9,
    MT10,
    MT11,
    MT12,
    MT_INSTITUTES,
    MT_NEWFORM,
    MT15,
    MT16,
    MT17,
    MT18,
    MT19
};

#define MENU_N      0
#define MENU_S      1
#define MENU_F      2
#define PULL_N      3
#define PULL_S      4
#define PULL_F      5
#define PULL_B      6
#define PULL_D      7
#define STAT_N      8
#define STAT_F      9
#define MESS_N      10
#define ERR_N       11
#define ERR_B       12
#define MAIN_N      13
#define MAIN_I    14
#define MAIN_S      15
#define WARN_N      16
#define HELPSCR_N   17
#define HELPSCR_T   18
#define HELPSCR_S   19
#define BROWSER_N   20
#define BROWSER_S   21
#define BROWSER_B   22
#define MEMOTAB   23
#define WAIT_N    24
#define WAIT_B    25

/*****************************************************************************\
|*                 Global variables.                                         *|
\*****************************************************************************/
extern char     chksn[44];
extern char    codename[7+1];
extern char    comm_drive[3];
extern char    comm_path[50];
extern char    comm_program[50];
extern int      custom[26];
extern char*    dbf[];
extern char     dbfpath[30];
extern int      doccreate;
extern char    docdrive[3];
extern char    docpath[50];
extern int      filtdoc_flag;
extern D4DATA *gl_dbfile;
extern X4FILTER gl_filter;
extern char     helpline_save[150];
extern int      maxsubdirlen;
extern char*    mes[];
extern H4FILE   net;
extern char    pattern[13];
extern char    privileges[10];
extern char*    sc[];
extern int      scol[40];
extern char     scrpath[30];
extern char     search_code[7+1];
extern C4CODE   set;
extern int      set_confirm;
extern char    iepdrive[3];
extern char    ieppath[50];
extern char    space_line[80];
extern int     srow[40];
extern char    statusline_save[150];
extern char    tmp_pathname[100];
extern char    user[7];
extern char    viewer[50];
extern char    wordprocessor[50];
/*****************************************************************************\
|*                 Prototypes for Microland Functions.                       *|
\*****************************************************************************/
int     actions();
int         add_user();
int     blank( char *, int );
int     browse(int, int, int, char *, D4DATA *, X4FILTER, F4FIELD **, int);
int     cclient();
int     check_password(char *, char *);
int     clen(char *, int);
int     commun();
int     copponent();
int     deb( int);
int     drel(int, int, D4DATA*, char*, D4DATA*, char*);
int     drel_att(int, int, D4DATA*, char*, D4DATA*, char*, int);
int     drelnum_att(int, int, D4DATA*, char*, D4DATA*, char*, int, int);
int     document();
int     economics();
int     employee();
char*       files( int );
int     filtcase();
int     filtclient();
int     filtjudge();
int     filto_lawyer();
int     filtopponent();
int     filtdoc();
int S4CALL  filter_basicfiles( void *);
int S4CALL  filter_cases( void *);
int S4CALL  filter_doc( void *);
int     get_input_positions(char *);
int     gcl_status(GET *, char *, int);
int     gfb(GET *, char *, int);
int     gfb_help(GET *, char *, int);
int     gfmaster_help(GET *, char *, int);
int     gfmaster(GET *, char *, int);
int     gfilename(GET *, char *, int);
int     gpassword(GET *, char *, int);
int     gper_comp(GET *, char *, int);
int     gsex(GET *, char *, int);
int     gtoupper( int );
int     help(char *);
void        helpline(char *);
int     judge();
int     kw(int, int, int, char*);
int     login();
int*        matint( int *, int, int );
int     o_lawyer();
int     pack();
int     pclient();
int     popponent();
char*       screens( int );
int     screen_file( char *, int, int );
int     search_files( char *);
char*       space( int );
void        statline( char *);
int     thecase();
int     vnot_empty(GET *);
int     warning( char *);
int     zerofill( char *, int );

/*****************************************************************************\
|*                 Data type structures.                                     *|
\*****************************************************************************/
typedef struct
{
    F4FIELD *field1;
    F4FIELD *field2;
    char find_info1[10];
    char find_info2[100];
    int compare_len1;
    int   compare_len2;
    } FILTER_INFO_BASIC;

typedef struct
{
    F4FIELD *field1;
    F4FIELD *field2;
    F4FIELD *field3;
    F4FIELD *field4;
    F4FIELD *field5;
    F4FIELD *field6;
    F4FIELD *field7;
    F4FIELD *field8;
    F4FIELD *field9;
    F4FIELD *field10;
    F4FIELD *field11;
    F4FIELD *field_from;
    F4FIELD *field_to;

    char find_info1[10];
    char find_info2[10];
    char find_info3[10];
    char find_info4[10];
    char find_info5[10];
    char find_info6[10];
    char find_info7[10];
    char find_info8[10];
    char find_info9[10];
    char find_info10[10];
    char find_info11[10];
    long find_from;
    long find_to;

    int compare_len1;
    int   compare_len2;
    int compare_len3;
    int   compare_len4;
    int compare_len5;
    int   compare_len6;
    int compare_len7;
    int   compare_len8;
    int compare_len9;
    int   compare_len10;
    int   compare_len11;
    int   compare_from;
    int   compare_to;
    } FILTER_INFO_CASE;


typedef struct
{
    F4FIELD *field1;
    F4FIELD *field2;
    F4FIELD *field3;
    F4FIELD *field4;
    F4FIELD *field_from;
    F4FIELD *field_to;

    char find_info1[10];
    char find_info2[10];
    char find_info3[10];
    char find_info4[20];
    long find_from;
    long find_to;

    int compare_len1;
    int   compare_len2;
    int compare_len3;
    int compare_len4;
    int   compare_from;
    int   compare_to;
    } FILTER_INFO_DOC;
