/*****************************************************************************/
/*  SELECTF.C                                                                */
/*****************************************************************************/
#include "microlib.h"
#ifdef __TURBOC__
#include <dir.h>
#elif defined _MSC_VER
#include <direct.h>
#include <compat.h>
#endif
#include <dos.h>

int display_item(int);
int change_directory(int);

int  search_files( getarea )
char *getarea;
{
	int  rc, w_ref, len ;

	for(;;) {
		rc = select_file( getarea );
		if(rc == 2000)
			continue;
		else if( rc == -27 ) {
			helpline(mes[MH+4]);
			return(0);
			}
		else if(rc != 3000 && rc != 0) {
			helpline(mes[MH+4]);
			return(0);
			}
		else {
		  /* Change Pattern Selected */
			w_ref =  w4define( 5,50, 9, 79 ) ;
			w4popup() ;
			w4memory();
			w4border( DOUBLE, custom[MAIN_N]) ;
			w4attribute(custom[MAIN_N]);
			w4activate( w_ref ) ;
			w4clear(0);
			w4( 1,3, mes[MH+30] ) ;					/* Pattern */
			len =  (int) strlen(pattern) ;
			memset( pattern+len, (int) ' ', 12-len ) ;
			pattern[12] =  '\0' ;
			g4delimiter("[]");
			g4attribute(custom[MAIN_I]);
			g4( 1, 14, pattern ) ;
			g4upper() ;

			g4read() ;
			w4deactivate( w_ref ) ;
			w4close( w_ref ) ;
			}
		}
	}


int  select_file( char *getarea )
{
	int  n_data;
	int  w_ref, m_ref, rc, i ;
	char count_data[14];

	struct ffblk ffblk;

	struct FST {
		char fname[14];
		} *fst;

	for( rc =  findfirst("*.*" ,&ffblk, FA_DIREC), n_data= 0; rc == 0;) {
		if(rc != 0) break;
		if(ffblk.ff_attrib == 0x10 && strcmp(ffblk.ff_name,  "."))
			n_data ++;
		rc =  findnext( &ffblk ) ;
		}

	for( rc =  findfirst(pattern ,&ffblk, 0); rc == 0; n_data ++)
	rc =  findnext( &ffblk ) ;

	w_ref =  w4define( 4, 74, 5,78 ) ;
	w4popup();
	w4memory();
	w4attribute(custom[BROWSER_N]);
	w4activate(w_ref);

	m_ref =  w4define( -1,-1,-1,-1 ) ;
	w4attribute(custom[BROWSER_N]);
	w4border( SINGLE, custom[BROWSER_B]) ;
	w4title( 0,-1, mes[MT+23], custom[BROWSER_B]) ;
#ifdef __TURBOC__
	n4attribute(custom[BROWSER_N], custom[BROWSER_S], custom[BROWSER_N]);
#else
    n4attribute(custom[BROWSER_N], custom[BROWSER_S]);
#endif
	n4( pattern );
	n4parm( -3000 ) ;
	n4skip_over(n4(""), 1 ) ;
	n4( "  ⚚ " );
	n4parm( 27 ) ;
	n4skip_over(n4(""), 1 ) ;

	helpline(docpath);

	if ( n_data > 0 ) {
		/* Allocate Enough File Memory */
		if( (fst =  (struct FST *) malloc( n_data * sizeof(struct FST) )) == NULL) {
			w4display(mes[MT], mes[ME+1], (char *) 0);
			return(-27);
			}

		/* Find Directories...       */
		for( rc =  findfirst("*.*" ,&ffblk, FA_DIREC), n_data= 0; rc == 0;) {
			if(rc != 0) break;
			if(ffblk.ff_attrib == 0x10 && strcmp(ffblk.ff_name,  ".")) {
				strcpy(fst[n_data].fname, ffblk.ff_name);
				n4( fst[n_data].fname ) ;
				n4action( change_directory ) ;
				n_data ++;
				}
			rc =  findnext( &ffblk ) ;
			}

		/* Find files that match the "pattern"...  */
		for( rc =  findfirst(pattern,&ffblk, 0); rc == 0;) {
			if(rc != 0) break;
			for(i = 0; ffblk.ff_name[i]; i++)
				fst[n_data].fname[i] = tolower(ffblk.ff_name[i]);
			fst[n_data].fname[i] = '\0';
			n4( fst[n_data].fname ) ;
			n4action( display_item ) ;
			n_data ++;

			rc =  findnext( &ffblk ) ;
			}
		} /* If n_data > 0 */


	else {
		n4skip_over(n4(" ᨮ "), 1 ) ;
		n4skip_over(n4("     "), 1 ) ;
		n4skip_over(n4("       "), 1 ) ;
		n4skip_over(n4("    椦!   "), 1 ) ;
		}
	n4calc( m_ref, 2,79 ) ; /* Put in upper right hand corner */
	n4key_set( 2,1 ) ;      /* ** Searching On ** */
	rc =  n4activate( m_ref ) ;

	if(rc != 27 && rc !=-3000 && rc !=-2000) {
		memcpy(getarea, space(12), 12);
		memcpy(getarea, n4item_text(rc * -1), strlen(n4item_text(rc * -1)));
		}

	if (n_data > 0) {
		free( fst ) ;
		}

	w4deactivate( w_ref );
	w4close( w_ref ) ;

	return(rc * -1) ;
}

static int  display_item( int item_ref )
{
	return(item_ref * -1) ;
	}

static int  change_directory( int item_ref )
{
	int ret_val;
	int len;

	chdir(n4item_text(item_ref));
	memcpy(docpath+3, space(50-3), 50-3);
	getcurdir(0, docpath+3);
	len = strlen(docpath);
	if(docpath[len-1] != '\\') {
		docpath[len] = '\\';
		docpath[len +1] = '\0';
		}
	if(strlen(docpath) >= 50) {
		w4display("", mes[ME+55], (char *) 0);
		chdir("..");
		memcpy(docpath+3, space(50-3), 50-3);
		getcurdir(0, docpath+3);
		len = strlen(docpath);
		if(docpath[len-1] != '\\') {
			docpath[len] = '\\';
			docpath[len +1] = '\0';
			}
		}
	helpline(docpath);
	return(-2000) ;
	}
